unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.TMSFNCGridDatabaseAdapter,
  DB, DBClient, MidasLib, FMX.Controls.Presentation, FMX.StdCtrls,
  FMX.TMSFNCCustomComponent, FMX.TMSFNCCustomGrid, FMX.TMSFNCTypes,
  FMX.TMSFNCUtils, FMX.TMSFNCGraphics, FMX.TMSFNCGraphicsTypes,
  FMX.TMSFNCGridCell, FMX.TMSFNCGridOptions, FMX.TMSFNCListBox,
  FMX.TMSFNCBitmapContainer, FMX.TMSFNCCustomControl,
  FMX.TMSFNCCustomScrollControl, FMX.TMSFNCGridData, FMX.TMSFNCGrid;

type
  TfrmTest = class(TForm)
    GrdAd: TTMSFNCGridDatabaseAdapter;
    BtnFillnGroup: TButton;
    Grd: TTMSFNCGrid;
    GrdConv: TTMSFNCListBox;
    TMSFNCGridDatabaseAdapter1: TTMSFNCGridDatabaseAdapter;
    procedure BtnFillnGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure FillGrd;
  public
    { Public declarations }
  end;

var
  frmTest: TfrmTest;

implementation

{$R *.fmx}

procedure TfrmTest.BtnFillnGroupClick(Sender: TObject);
begin
    FillGrd;
end;

procedure TfrmTest.FillGrd;
function GetDS: TDataSource;
var
DS: TDataSource;
CD: TClientDataSet;
begin
    DS := TDataSource.Create(Nil);
    CD := TClientDataSet.Create(Nil);
    CD.FieldDefs.Add('GroupColumn',ftString,31);
    CD.FieldDefs.Add('HiddenColumn',ftString,31);
    CD.FieldDefs.Add('C1',ftString,31);
    CD.FieldDefs.Add('C2',ftString,31);
    CD.CreateDataSet;
    CD.Open;
    CD.Append;
    CD.FieldByName('GroupColumn').Text := 'G1';
    CD.FieldByName('HiddenColumn').Text := '123';
    CD.FieldByName('C1').Text := 'Data1';
    CD.FieldByName('C2').Text := 'Data2';
    CD.Append;
    CD.FieldByName('GroupColumn').Value := 'G1';
    CD.FieldByName('HiddenColumn').Value := '234';
    CD.FieldByName('C1').Value := 'Data11';
    CD.FieldByName('C2').Value := 'Data21';
    CD.Append;
    CD.FieldByName('GroupColumn').Value := 'G2';
    CD.FieldByName('HiddenColumn').Value := '345';
    CD.FieldByName('C1').Value := 'Data22';
    CD.FieldByName('C2').Value := 'Data222';
    //CD.Close;
    Result := DS;
end;
begin
    GrdAd.Active := False;
    {Grd.ColumnCount := 4;
    Grd.RowCount := 1;
    Grd.FixedRows := 1;
    Grd.FixedColumns := 1;}
    Grd.Adapter := GrdAd;
    GrdAd.Grid := Grd;
    GrdAd.DataSource := Nil;
    GrdAd.DataSource := GetDS;
    GrdAd.Active := True;
    GrdAd.LoadAllDataAndDisconnect;
    Grd.Group(1);
    //Grd.SortGrouped(1, sdAscending);
    Grd.AutoSizeColumns;
end;

procedure TfrmTest.FormCreate(Sender: TObject);
begin
    FillGrd;
end;

end.
